security:
    # https://symfony.com/doc/current/security/authenticator_manager.html
    enable_authenticator_manager: true
    # https://symfony.com/doc/current/security.html#c-hashing-passwords
    password_hashers:
        Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface: 'auto'
        App\Entity\User:
            algorithm: auto

    # https://symfony.com/doc/current/security.html#where-do-users-come-from-user-providers
    providers:
        # used to reload user from session & other features (e.g. switch_user)
        app_user_provider:
            entity:
                class: App\Entity\User
                property: email
    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false
        main:
            lazy: true
            provider: app_user_provider
            custom_authenticator: App\Security\LoginFormControllerAuthenticator
            logout:
                path: app_logout
                # where to redirect after logout
                # target: app_any_route

            access_denied_handler: App\Security\AccessDeniedHandler
            # activate different ways to authenticate
            # https://symfony.com/doc/current/security.html#firewalls-authentication

            # https://symfony.com/doc/current/security/impersonating_user.html
            # switch_user: true
    role_hierarchy:
        ROLE_USER: ROLE_USER # Gestionnaire de contenu
        ROLE_ACCOUNTANT: [ROLE_ACCOUNTANT,ROLE_USER] # Comptable
        ROLE_DEVELOPER: [ROLE_DEVELOPER,ROLE_USER] # Développeur
        ROLE_ADMIN: [ROLE_ADMIN,ROLE_DEVELOPER,ROLE_ACCOUNTANT,ROLE_USER] # Tous les rôles du dessus
        ROLE_SUPER_ADMIN: [ROLE_SUPER_ADMIN,ROLE_ADMIN,ROLE_DEVELOPER,ROLE_ACCOUNTANT,ROLE_USER] # Tous les rôles

    # Easy way to control access for large sections of your site
    # Note: Only the *first* access control that matches will be used
    access_control:
        - { path: ^/admin, roles: ROLE_USER }
        - { path: ^/admin/record, roles: ROLE_USER }
        - { path: ^/admin/user, roles: ROLE_ADMIN }
        - { path: ^/admin/item, roles: ROLE_DEVELOPER }
        - { path: ^/admin/site, roles: ROLE_DEVELOPER }
        - { path: ^/profile, roles: ROLE_USER }
